//tables
//
// Dec 2001 RDB	16F87X support
//			split equArry into equArry for registers and 
//			 miscArry for everything else
//			redesigned equArry array to support all 32 regs in each bank
//			added 16F87X registers
//
var instrTab = Array();      //Opcode look up table
instrTab[0]  = Array("addwf",     "*,*", 0x0700,	"dualAWDst",0xFF00,	0x7F);
instrTab[1]  = Array("andwf",     "*,*", 0x0500,	"dualAWDst",0xFF00,	0x7F);
instrTab[2]  = Array("clrf",      "*",   0x0180,	"oneArgF"  ,0xFF80,	0x7F);
instrTab[3]  = Array("clrw",      "",    0x0100,	"asIs"     ,0xFF80		);
instrTab[4]  = Array("comf",      "*,*", 0x0900,	"dualAWDst",0xFF00,	0x7F);
instrTab[5]  = Array("decf",      "*,*", 0x0300,	"dualAWDst",0xFF00,	0x7F);
instrTab[6]  = Array("decfsz",    "*,*", 0x0B00,	"dualAWDst",0xFF00,	0x7F);
instrTab[7]  = Array("incf",      "*,*", 0x0A00,	"dualAWDst",0xFF00,	0x7F);
instrTab[8]  = Array("incfsz",    "*,*", 0x0F00,	"dualAWDst",0xFF00,	0x7F);
instrTab[9]  = Array("iorwf",     "*,*", 0x0400,	"dualAWDst",0xFF00,	0x7F);
instrTab[10] = Array("movf",      "*,*", 0x0800,	"dualAWDst",0xFF00,	0x7F);
instrTab[11] = Array("movwf",     "*",   0x0080,	"oneArgF"  ,0xFF80,	0x7F);
instrTab[12] = Array("nop",  	  "",    0x0000,	"asIs"     ,0xFF9F		);
instrTab[13] = Array("rlf",	      "*,*", 0x0D00,	"dualAWDst",0xFF00,	0x7F);
instrTab[14] = Array("rrf",	      "*,*", 0x0C00,	"dualAWDst",0xFF00,	0x7F);
instrTab[15] = Array("subwf",     "*,*", 0x0200,	"dualAWDst",0xFF00,	0x7F);
instrTab[16] = Array("swapf",     "*,*", 0x0E00,	"dualAWDst",0xFF00,	0x7F);
instrTab[17] = Array("xorwf",     "*,*", 0x0600,	"dualAWDst",0xFF00,	0x7F);
instrTab[18] = Array("bcf",	      "*,*", 0x1000,	"bit",	    0xFC00,	0x7F);
instrTab[19] = Array("bsf",	      "*,*", 0x1400,	"bit",	    0xFC00,	0x7F);
instrTab[20] = Array("btfsc",     "*,*", 0x1800,	"bit",	    0xFC00,	0x7F);
instrTab[21] = Array("btfss",     "*,*", 0x1C00,	"bit",	    0xFC00,	0x7F);
instrTab[22] = Array("addlw",     "*",   0x3E00,	"oneArgL"  ,0xFE00,	0x00FF);
instrTab[23] = Array("andlw",     "*",   0x3900,	"oneArgL"  ,0xFF00,	0x00FF);
instrTab[24] = Array("call",      "*",   0x2000,	"oneArgA"  ,0xF800,	0x07FF);
instrTab[25] = Array("clrwdt",    "",    0x0064,	"asIs"     ,0xFFFF			);
instrTab[26] = Array("goto",      "*",   0x2800,	"oneArgA"  ,0xF800,	0x07FF);
instrTab[27] = Array("iorlw",     "*",   0x3800,	"oneArgL"  ,0xFF00,	0x00FF);
instrTab[28] = Array("movlw",     "*",   0x3000,	"oneArgL"  ,0xFC00,	0x00FF);
instrTab[29] = Array("retfie",    "",    0x0009,	"asIs"     ,0xFFFF		);
instrTab[30] = Array("retlw",     "*",   0x3400,	"oneArgL"  ,0xFC00,	0x00FF);
instrTab[31] = Array("return",    "",    0x0008,	"asIs"     ,0xFFFF		);
instrTab[32] = Array("sleep",     "",    0x0063,	"asIs"     ,0xFFFF		);
instrTab[33] = Array("sublw",     "*",   0x3C00,	"oneArgL"  ,0xFE00,	0x00FF	);
instrTab[34] = Array("xorlw",     "*",   0x3A00,	"oneArgL"  ,0xFF00,	0x00FF	);
//obsolete  instrTab[35] = Array("tris",      "*",   0x0060,	"oneArgL",	0xFFF8, 0x0007);

// indices for equArry and miscArry
var equStr = 0; //string
var equStrVal = 1;//value of string
var clrNdx = 2; // type of text to color (see colors.js)

var equArry = Array();//register lookup table

//----- Register Files Page 0 ------------
equArry[0]  =  Array("indf"	 ,0x0000,2);
equArry[1]  =  Array("tmr0"	 ,0x0001,0);
equArry[2]  =  Array("pcl"	 ,0x0002,2);
equArry[3]  =  Array("status"	 ,0x0003,2);
equArry[4]  =  Array("fsr"	 ,0x0004,2);
equArry[5]  =  Array("porta"	 ,0x0005,0);
equArry[6]  =  Array("portb"	 ,0x0006,0);
equArry[7]  =  Array("portc"	 ,0x0007,0);
equArry[8]  =  Array("portd"	 ,0x0008,0);
equArry[9]  =  Array("porte"	 ,0x0009,0);
equArry[10] =  Array("pclath"	 ,0x000A,2);
equArry[11] =  Array("intcon"	 ,0x000B,2);
equArry[12] =  Array("pir1"	 ,0x000C,0);
equArry[13] =  Array("oir2"	 ,0x000D,0);
equArry[14] =  Array("tmr1l"	 ,0x000E,0);
equArry[15] =  Array("tmr1h"	 ,0x000F,0);
equArry[16] =  Array("t1con"	 ,0x0010,0);
equArry[17] =  Array("tmr2"	 ,0x0011,0);
equArry[18] =  Array("t2con"	 ,0x0012,0);
equArry[19] =  Array("sspbuf"	 ,0x0013,0);
equArry[20] =  Array("sspcon"	 ,0x0014,0);
equArry[21] =  Array("ccpr1l"	 ,0x0015,0);
equArry[22] =  Array("ccpr1h"	 ,0x0016,0);
equArry[23] =  Array("ccp1con"	 ,0x0017,0);
equArry[24] =  Array("rcsta"	 ,0x0018,0);
equArry[25] =  Array("txreg"	 ,0x0019,0);
equArry[26] =  Array("rcreg"	 ,0x001A,0);
equArry[27] =  Array("ccpr2l"	 ,0x001B,0);
equArry[28] =  Array("ccpr2h"	 ,0x001C,0);
equArry[29] =  Array("ccp2con"	 ,0x001D,0);
equArry[30] =  Array("adresh"	 ,0x001E,0);
equArry[31] =  Array("adcon0"	 ,0x001F,0);


//----- Register Files Page 1 ------------
equArry[32] =  Array("indf"	 ,0x0080,2);
equArry[33] =  Array("option_reg",0x0081,1);
equArry[34] =  Array("pcl"   	 ,0x0082,2);
equArry[35] =  Array("status"	 ,0x0083,2);
equArry[36] =  Array("fsr"   	 ,0x0084,2);
equArry[37] =  Array("trisa"     ,0x0085,1);
equArry[38] =  Array("trisb"     ,0x0086,1);
equArry[39] =  Array("trisc"     ,0x0087,1);
equArry[40] =  Array("trisd"     ,0x0088,1);
equArry[41] =  Array("trise"     ,0x0089,1);
equArry[42] =  Array("pclath"	 ,0x008A,2);
equArry[43] =  Array("intcon"	 ,0x008B,2);
equArry[44] =  Array("pie1"      ,0x008C,1);
equArry[45] =  Array("pie2"      ,0x008D,1);
equArry[46] =  Array("pcon"      ,0x008E,1);
equArry[47] =  Array("undefined" ,0x008F,14);
equArry[48] =  Array("undefined" ,0x0090,14);
equArry[49] =  Array("sspcon2"   ,0x0091,1);
equArry[50] =  Array("pr2"       ,0x0092,1);
equArry[51] =  Array("sspadd"    ,0x0093,1);
equArry[52] =  Array("sspstat"   ,0x0094,1);
equArry[53] =  Array("undefined" ,0x0095,14);
equArry[54] =  Array("undefined" ,0x0096,14);
equArry[55] =  Array("undefined" ,0x0097,14);
equArry[56] =  Array("txsta"     ,0x0098,1);
equArry[57] =  Array("spbrg"     ,0x0099,1);
equArry[58] =  Array("undefined" ,0x009A,14);
equArry[59] =  Array("undefined" ,0x009B,14);
equArry[60] =  Array("undefined" ,0x009C,14);
equArry[61] =  Array("undefined" ,0x009D,14);
equArry[62] =  Array("adresl"    ,0x009E,1);
equArry[63] =  Array("adcon1"    ,0x009F,1);


//----- Register Files Page 2 ------------
equArry[64]  = Array("indf"	 ,0x0100,2);
equArry[65]  = Array("tmr0"	 ,0x0101,0);
equArry[66]  = Array("pcl"   	 ,0x0102,2);
equArry[67]  = Array("status"	 ,0x0103,2);
equArry[68]  = Array("fsr"   	 ,0x0104,2);
equArry[69]  = Array("undefined" ,0x0105,14);
equArry[70]  = Array("portb" 	 ,0x0106,0);
equArry[71]  = Array("undefined" ,0x0107,14);
equArry[72]  = Array("undefined" ,0x0108,14);
equArry[73]  = Array("undefined" ,0x0109,14);
equArry[74]  = Array("pclath"	 ,0x010A,2);
equArry[75]  = Array("intcon"	 ,0x010B,2);
equArry[76]  = Array("eedata"	 ,0x010C,1);
equArry[77]  = Array("eeadr" 	 ,0x010D,1);
equArry[78]  = Array("eedath"	 ,0x010E,1);
equArry[79]  = Array("eeadrh"	 ,0x010F,1);
equArry[80]  = Array("undefined" ,0x0110,14);
equArry[81]  = Array("undefined" ,0x0111,14);
equArry[82]  = Array("undefined" ,0x0112,14);
equArry[83]  = Array("undefined" ,0x0113,14);
equArry[84]  = Array("undefined" ,0x0114,14);
equArry[85]  = Array("undefined" ,0x0115,14);
equArry[86]  = Array("undefined" ,0x0116,14);
equArry[87]  = Array("undefined" ,0x0117,14);
equArry[88]  = Array("undefined" ,0x0118,14);
equArry[89]  = Array("undefined" ,0x0119,14);
equArry[90]  = Array("undefined" ,0x011A,14);
equArry[91]  = Array("undefined" ,0x011B,14);
equArry[92]  = Array("undefined" ,0x011C,14);
equArry[93]  = Array("undefined" ,0x011D,14);
equArry[94]  = Array("undefined" ,0x011E,14);
equArry[95]  = Array("undefined" ,0x011F,14);


//----- Register Files Page 3 ------------
equArry[96]  = Array("indf"	 ,0x0180,2);
equArry[97]  = Array("option_reg",0x0181,1);
equArry[98]  = Array("pcl"   	 ,0x0182,2);
equArry[99]  = Array("pcl"   	 ,0x0182,2);
equArry[100] = Array("status"	 ,0x0183,2);
equArry[101] = Array("fsr"   	 ,0x0184,2);
equArry[102] = Array("undefined" ,0x0185,14);
equArry[103] = Array("trisb"     ,0x0186,1);
equArry[104] = Array("undefined" ,0x0187,14);
equArry[105] = Array("undefined" ,0x0188,14);
equArry[106] = Array("undefined" ,0x0189,14);
equArry[107] = Array("pclath"	 ,0x018A,2);
equArry[108] = Array("intcon"	 ,0x018B,2);
equArry[109] = Array("eecon1"    ,0x018C,1);
equArry[110] = Array("eecon2"    ,0x018D,1);
equArry[111] = Array("undefined" ,0x018E,14);
equArry[112] = Array("undefined" ,0x018F,14);
equArry[113] = Array("undefined" ,0x0190,14);
equArry[114] = Array("undefined" ,0x0191,14);
equArry[115] = Array("undefined" ,0x0192,14);
equArry[116] = Array("undefined" ,0x0193,14);
equArry[117] = Array("undefined" ,0x0194,14);
equArry[118] = Array("undefined" ,0x0195,14);
equArry[119] = Array("undefined" ,0x0196,14);
equArry[120] = Array("undefined" ,0x0197,14);
equArry[121] = Array("undefined" ,0x0198,14);
equArry[122] = Array("undefined" ,0x0199,14);
equArry[123] = Array("undefined" ,0x019A,14);
equArry[124] = Array("undefined" ,0x019B,14);
equArry[125] = Array("undefined" ,0x019C,14);
equArry[126] = Array("undefined" ,0x019D,14);
equArry[127] = Array("undefined" ,0x019E,14);
equArry[128] = Array("undefined" ,0x019F,14);


var miscArry = Array();//misc string lookups

miscArry[0]  =  Array("w"	,0x0000,13);
miscArry[1]  =  Array("f"	,0x0001,13);
//;----- Selected STATUS Bits ---------------------
miscArry[2]  =  Array("irp"	,0x0007,3);
miscArry[3]  =  Array("rp1"   	,0x0006,3);
miscArry[4]  =  Array("rp0"   	,0x0005,3);
miscArry[5]  =  Array("not_to"	,0x0004,3);
miscArry[6]  =  Array("not_pd"	,0x0003,3);
miscArry[7]  =  Array("z"	,0x0002,3);
miscArry[8]  =  Array("dc"	,0x0001,3);
miscArry[9]  =  Array("c"	,0x0000,3);
//;----- INTCON Bits ---------------------
miscArry[10] =  Array("gie"	,0x0007,4);
miscArry[11] =  Array("eeie"	,0x0006,4);
miscArry[12] =  Array("t0ie"	,0x0005,4);
miscArry[13] =  Array("inte"	,0x0004,4);
miscArry[14] =  Array("rbie"	,0x0003,4);
miscArry[15] =  Array("t0if"	,0x0002,4);
miscArry[16] =  Array("intf"	,0x0001,4);
miscArry[17] =  Array("rbif"	,0x0000,4);
//;----- OPTION Bits ---------------------
miscArry[18] =  Array("not_rbpu",0x0007,5);
miscArry[19] =  Array("intedg"  ,0x0006,5);
miscArry[20] =  Array("t0cs"    ,0x0005,5);
miscArry[21] =  Array("t0se"    ,0x0004,5);
miscArry[22] =  Array("psa"     ,0x0003,5);
miscArry[23] =  Array("ps2"     ,0x0002,5);
miscArry[24] =  Array("ps1"     ,0x0001,5);
miscArry[25] =  Array("ps0"     ,0x0000,5);
//;----- EECON1 Bits ---------------------
miscArry[26] =  Array("eeif" 	,0x0004,6);
miscArry[27] =  Array("wrerr"	,0x0003,6);
miscArry[28] =  Array("wren" 	,0x0002,6);
miscArry[29] =  Array("wr"   	,0x0001,6);
miscArry[30] =  Array("rd"   	,0x0000,6);
//;----- Extra/Duplicates ---------------------
miscArry[31] =  Array("carry"   ,0x0000,3);// status bit

//;----- Config bits ---------------------
miscArry[32]  =  Array("_cp_on"		,0x000F,7);
miscArry[33]  =  Array("_cp_off"	,0x3FFF,7);
miscArry[34]  =  Array("_pwrte_on"	,0x3FF7,7);
miscArry[35]  =  Array("_pwrte_off"	,0x3FFF,7);
miscArry[36]  =  Array("_wdt_on"	,0x3FFF,7);
miscArry[37]  =  Array("_wdt_off"	,0x3FFB,7);
miscArry[38]  =  Array("_lp_osc"	,0x3FFC,7);
miscArry[39]  =  Array("_xt_osc"	,0x3FFD,7);
miscArry[40]  =  Array("_hs_osc"	,0x3FFE,7);
miscArry[41]  =  Array("_rc_osc"	,0x3FFF,7);


var asciiTable = " "+"!"+'\"'+"#"+"$"+"%"+"&"+'\''+"("+")"+"*"+"+"+","+"-"+"."+"/"+"0"+"1"+"2"+"3"+"4"+"5"+"6"+"7"+"8"+"9"+":"+";"+"<"+"="+">"+"?"+"@"+"A"+"B"+"C"+"D"+"E"+"F"+"G"+"H"+"I"+"J"+"K"+"L"+"M"+"N"+"O"+"P"+"Q"+"R"+"S"+"T"+"U"+"V"+"W"+"X"+"Y"+"Z"+"["+"\\"+"]"+"^"+"_"+"`"+"a"+"b"+"c"+"d"+"e"+"f"+"g"+"h"+"i"+"j"+"k"+"l"+"m"+"n"+"o"+"p"+"q"+"r"+"s"+"t"+"u"+"v"+"w"+"x"+"y"+"z"+"{"+"|"+"}"+"~"+"";

var asmDirArry = Array();
asmDirArry[0] = "equ";
asmDirArry[1] = "org";
asmDirArry[2] = "dt";
asmDirArry[3] = "radix";
asmDirArry[4] = "__config";
asmDirArry[5] = "macro";
asmDirArry[6] = "endm";
asmDirArry[7] = "data";
asmDirArry[8] = "if";
asmDirArry[9] = "else";
asmDirArry[10] = "end";
asmDirArry[11] = "elif";
asmDirArry[12] = "include";
asmDirArry[13] = "errorlevel";
asmDirArry[14] = "list";
asmDirArry[15] = "__idlocs";
asmDirArry[16] = "de";
asmDirArry[17] ="db";
asmDirArry[18] ="data";
asmDirArry[19] ="#define";
asmDirArry[20] ="dw";
asmDirArry[21] ="endc";
asmDirArry[22] ="endif";
asmDirArry[23] ="endw";
asmDirArry[24] ="error";
asmDirArry[25] ="exitm";
asmDirArry[26] ="expand";
asmDirArry[27] ="extern";
asmDirArry[28] ="fill";
asmDirArry[29] ="global";
asmDirArry[30] ="ifdef";
asmDirArry[31] ="ifndef";
asmDirArry[32] ="include";
asmDirArry[33] ="local";
asmDirArry[34] ="__maxram";
asmDirArry[35] ="messg";
asmDirArry[36] ="noexpand";
asmDirArry[37] ="nolist";
asmDirArry[38] ="page";
asmDirArry[39] ="pagesel";
asmDirArry[40] ="processor";
asmDirArry[41] ="res ";
asmDirArry[42] ="set";
asmDirArry[43] ="space";
asmDirArry[44] ="subtitle";
asmDirArry[45] ="title";
asmDirArry[46] ="#undefine";
asmDirArry[47] ="while";

//rules for operators
var rule = 1 ;//dim 2
var oprtr = 0; //dim 1
var binary = 0;
var unary = 1;
var both = 2;
var lpar = 3;
var rpar = 4;

var operArry = Array();

operArry[0 ] = 	Array(",",binary);
operArry[1 ] = 	Array("%",binary);
operArry[2 ] = 	Array("++",unary);
operArry[3 ] = 	Array("+",both);
operArry[4 ] = 	Array("+=",binary);
operArry[5 ] = 	Array("--",unary);
operArry[6 ] =	Array("-=",binary);
operArry[7 ] = 	Array("-",both);
operArry[8 ] =	Array("*=",binary);
operArry[9 ] = 	Array("*",binary);
operArry[10] =	Array("/=",binary);
operArry[11] = 	Array("/",binary);
operArry[12] =	Array(">=",binary);
operArry[13] = 	Array("&&",binary);
operArry[14] =	Array("&=",binary);
operArry[15] =	Array("&",binary);
operArry[16] =	Array("||",binary);
operArry[17] =	Array("|=",binary);
operArry[18] =	Array("|",binary);
operArry[19] =	Array("==",binary);
operArry[20] =	Array("<<=",binary);
operArry[21] =	Array(">>=",binary);
operArry[22] =	Array("<<",binary);
operArry[23] =	Array(">>",binary);
operArry[24] =	Array("<=",binary);
operArry[25] =	Array(">=",binary);
operArry[26] =	Array(">",binary);
operArry[27] =	Array("<",binary);
operArry[28] =	Array("!=",binary);
operArry[29] =	Array("!",unary);
operArry[30] =	Array("^=",binary);
operArry[31] =	Array("^",binary);
operArry[32] =	Array("%=",binary);
operArry[33] =	Array("(",lpar);
operArry[34] =	Array(")",rpar);
operArry[35] =	Array("=",binary);
operArry[36] =	Array("~",unary);
